/*******************************************************************************
  File: E2A.h
  Copyright (c) 1999 Bleading Edge Software Technologies, Inc.

  This Software is distributed under the open source, free software model.
  Permission to use, modify, and distribute this Software, including
  incorporating it into proprietary software, is granted without fee, 
  provided this copyright notice appear in all copies of the code.
  You are under no obligation to distribute source code which is derived from
  or uses this Software. You may not do anything however, such as copyrighting
  or claiming authorship, to prevent the continued distribution of this 
  Software under an open source distribution model.
  This Software is distributed in the hope that it will be useful, but it is
  provide "as is", WITHOUT ANY WARRANTY; without even the implied warranty
  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

//$----------------------------------------------------------------------------|
$Header: $
  Author: Jack W. Reeves

//!----------------------------------------------------------------------------|
Description:
  An EBCDIC to/from ASCII converter.

//%****************************************************************************************/
#ifndef UTIL_E2A_H
#define UTIL_E2A_H

// Platform header
#include <platform.h>

// Standard C++ headers
#include <std/functional>

namespace Util {

//
// EBCDIC <-> ASCII conversion
//
struct EBCDIC2ASCII : std::unary_function<char, char> {
	static const unsigned char e2a[256];
	char operator()(char c) const {
		return e2a[static_cast<unsigned char>(c)];
	}
};

struct ASCII2EBCDIC : std::unary_function<char, char> {
	static const unsigned char a2e[256];
	char operator()(char c) const {
		return a2e[static_cast<unsigned char>(c)];
	}
};

} //> namespace Util

#endif
