/*	Copyright (C) 2001,2002,2003 Ronnie Maor and Michael Brand
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * As a special exception, the copyright holders give permission
 * for additional uses of the text contained in its release of XPARAM.
 *
 * The exception is that, if you link the XPARAM library with other files
 * to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the XPARAM library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * If you write modifications of your own for XPARAM, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.  
 */


#pragma warning (disable: 4101)

/* $ANTLR 2.7.1: "lexer.g" -> "xParamLexer.cpp"$ */
#include <../src_include/xParamLexer.hpp>
#include "antlr/CharBuffer.hpp"
#include "antlr/TokenStreamException.hpp"
#include "antlr/TokenStreamIOException.hpp"
#include "antlr/TokenStreamRecognitionException.hpp"
#include "antlr/CharStreamException.hpp"
#include "antlr/CharStreamIOException.hpp"
#include "antlr/NoViableAltForCharException.hpp"



#include "../xparam/xp_error.h"

using namespace antlr;
using namespace std;


ANTLR_BEGIN_NAMESPACE(xParam_internal)



xParamLexer::xParamLexer(std::istream& in)
	: antlr::CharScanner(new antlr::CharBuffer(in))
{
	setCaseSensitive(true);
	initLiterals();
}

xParamLexer::xParamLexer(antlr::InputBuffer& ib)
	: antlr::CharScanner(ib)
{
	setCaseSensitive(true);
	initLiterals();
}

xParamLexer::xParamLexer(const antlr::LexerSharedInputState& state)
	: antlr::CharScanner(state)
{
	setCaseSensitive(true);
	initLiterals();
}

void xParamLexer::initLiterals()
{
	literals["["] = 12;
	literals[")"] = 11;
	literals[","] = 14;
	literals["]"] = 13;
	literals[";"] = 4;
	literals["("] = 10;
	literals["="] = 7;
}
bool xParamLexer::getCaseSensitiveLiterals() const
{
	return true;
}

antlr::RefToken xParamLexer::nextToken()
{
	antlr::RefToken theRetToken;
	for (;;) {
		antlr::RefToken theRetToken;
		int _ttype = antlr::Token::INVALID_TYPE;
		resetText();
		try {   // for char stream error handling
			try {   // for lexical error handling
				if ((_tokenSet_0.member(LA(1)))) {
					mMAIN_SWITCH(true);
					theRetToken=_returnToken;
				}
				else {
					if (LA(1)==EOF_CHAR) {uponEOF(); _returnToken = makeToken(antlr::Token::EOF_TYPE);}
				else {throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());}
				}
				
				if ( !_returnToken ) goto tryAgain; // found SKIP token
				_ttype = _returnToken->getType();
				_ttype = testLiteralsTable(_ttype);
				_returnToken->setType(_ttype);
				return _returnToken;
			}
			catch (antlr::RecognitionException& e) {
				throw antlr::TokenStreamRecognitionException(e);
			}
		}
		catch (antlr::CharStreamIOException& csie) {
		   throw antlr::TokenStreamIOException(csie.io);
		}
		catch (antlr::CharStreamException& cse) {
		   throw antlr::TokenStreamException(cse.getMessage());
		}
tryAgain:;
	}
}

void xParamLexer::mGLUE_CHAR(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = GLUE_CHAR;
	int _saveIndex;
	
	match(static_cast<unsigned char>('\1'));
	if ( inputState->guessing==0 ) {

		assert(cmdline_glue_char() == 1);

	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mWS(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = WS;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('\1'):
	{
		mGLUE_CHAR(false);
		break;
	}
	case static_cast<unsigned char>(' '):
	{
		match(static_cast<unsigned char>(' '));
		break;
	}
	case static_cast<unsigned char>('\t'):
	{
		match(static_cast<unsigned char>('\t'));
		break;
	}
	case static_cast<unsigned char>('\r'):
	{
		match(static_cast<unsigned char>('\r'));
		break;
	}
	case static_cast<unsigned char>('\n'):
	{
		match(static_cast<unsigned char>('\n'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mSINGLE_LINE_WS(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = SINGLE_LINE_WS;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('\1'):
	{
		mGLUE_CHAR(false);
		break;
	}
	case static_cast<unsigned char>(' '):
	{
		match(static_cast<unsigned char>(' '));
		break;
	}
	case static_cast<unsigned char>('\t'):
	{
		match(static_cast<unsigned char>('\t'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mMAIN_SWITCH(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = MAIN_SWITCH;
	int _saveIndex;
	
	try {      // for error handling
		switch ( LA(1)) {
		case static_cast<unsigned char>('('):
		case static_cast<unsigned char>(')'):
		case static_cast<unsigned char>(','):
		case static_cast<unsigned char>(';'):
		case static_cast<unsigned char>('='):
		case static_cast<unsigned char>('['):
		case static_cast<unsigned char>(']'):
		case static_cast<unsigned char>('{'):
		case static_cast<unsigned char>('}'):
		{
			mRESERVED_SYMBOL(false);
			break;
		}
		case static_cast<unsigned char>('\1'):
		case static_cast<unsigned char>('\t'):
		case static_cast<unsigned char>('\n'):
		case static_cast<unsigned char>('\r'):
		case static_cast<unsigned char>(' '):
		{
			{
			int _cnt6=0;
			for (;;) {
				if ((_tokenSet_1.member(LA(1)))) {
					mWS(false);
				}
				else {
					if ( _cnt6>=1 ) { goto _loop6; } else {throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());}
				}
				
				_cnt6++;
			}
			_loop6:;
			}
			if ( inputState->guessing==0 ) {

				_ttype = Token::SKIP;

			}
			break;
		}
		case static_cast<unsigned char>('#'):
		{
			mCOMMENT(false);
			if ( inputState->guessing==0 ) {

				_ttype = Token::SKIP;

			}
			break;
		}
		case static_cast<unsigned char>('\''):
		{
			mCHAR(false);
			if ( inputState->guessing==0 ) {

				_ttype = CHAR;

			}
			break;
		}
		case static_cast<unsigned char>('"'):
		{
			mSTRING(false);
			if ( inputState->guessing==0 ) {

				_ttype = STRING;

			}
			break;
		}
		case static_cast<unsigned char>('@'):
		{
			mURL(false);
			if ( inputState->guessing==0 ) {

				_ttype = URL;

			}
			break;
		}
		default:
			bool synPredMatched9 = false;
			if (((_tokenSet_2.member(LA(1))))) {
				int _m9 = mark();
				synPredMatched9 = true;
				inputState->guessing++;
				try {
					{
					mID(false);
					{
					switch ( LA(1)) {
					case static_cast<unsigned char>('<'):
					{
						match(static_cast<unsigned char>('<'));
						break;
					}
					case static_cast<unsigned char>('('):
					{
						match(static_cast<unsigned char>('('));
						break;
					}
					case static_cast<unsigned char>(':'):
					{
						match("::");
						break;
					}
					default:
					{
						throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
					}
					}
					}
					}
				}
				catch (antlr::RecognitionException& pe) {
					synPredMatched9 = false;
				}
				rewind(_m9);
				inputState->guessing--;
			}
			if ( synPredMatched9 ) {
				mTYPENAME(false);
				if ( inputState->guessing==0 ) {

					_ttype = TYPENAME;

				}
			}
			else {
				bool synPredMatched13 = false;
				if (((_tokenSet_2.member(LA(1))))) {
					int _m13 = mark();
					synPredMatched13 = true;
					inputState->guessing++;
					try {
						{
						mID(false);
						{
						if ((_tokenSet_3.member(LA(1)))) {
							{
							match(_tokenSet_3);
							}
						}
						else if (true&&(LA(1) == EOF_CHAR)) {
						}
						else {
							throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
						}
						
						}
						}
					}
					catch (antlr::RecognitionException& pe) {
						synPredMatched13 = false;
					}
					rewind(_m13);
					inputState->guessing--;
				}
				if ( synPredMatched13 ) {
					mID(false);
					if ( inputState->guessing==0 ) {

						_ttype = ID;

					}
				}
				else {
					bool synPredMatched15 = false;
					if (((LA(1)==static_cast<unsigned char>('-')))) {
						int _m15 = mark();
						synPredMatched15 = true;
						inputState->guessing++;
						try {
							{
							mFLAG(false);
							}
						}
						catch (antlr::RecognitionException& pe) {
							synPredMatched15 = false;
						}
						rewind(_m15);
						inputState->guessing--;
					}
					if ( synPredMatched15 ) {
						mFLAG(false);
						if ( inputState->guessing==0 ) {

							_ttype = FLAG;

						}
					}
					else if ((_tokenSet_4.member(LA(1)))) {
						mTENTATIVE(false);
						if ( inputState->guessing==0 ) {

							_ttype = TENTATIVE;

						}
					}
		else {
			throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
		}
		}}}
	}
	catch (RecognitionException& ex) {
		if (inputState->guessing==0) {

			
					throw Error("illegal token - " + getText());
				

		} else {
			throw ex;
		}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mRESERVED_SYMBOL(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = RESERVED_SYMBOL;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('('):
	{
		match(static_cast<unsigned char>('('));
		break;
	}
	case static_cast<unsigned char>(')'):
	{
		match(static_cast<unsigned char>(')'));
		break;
	}
	case static_cast<unsigned char>('['):
	{
		match(static_cast<unsigned char>('['));
		break;
	}
	case static_cast<unsigned char>(']'):
	{
		match(static_cast<unsigned char>(']'));
		break;
	}
	case static_cast<unsigned char>('{'):
	{
		match(static_cast<unsigned char>('{'));
		break;
	}
	case static_cast<unsigned char>('}'):
	{
		match(static_cast<unsigned char>('}'));
		break;
	}
	case static_cast<unsigned char>('='):
	{
		match(static_cast<unsigned char>('='));
		break;
	}
	case static_cast<unsigned char>(','):
	{
		match(static_cast<unsigned char>(','));
		break;
	}
	case static_cast<unsigned char>(';'):
	{
		match(static_cast<unsigned char>(';'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mCOMMENT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = COMMENT;
	int _saveIndex;
	
	match(static_cast<unsigned char>('#'));
	{
	for (;;) {
		if ((_tokenSet_5.member(LA(1)))) {
			matchNot(static_cast<unsigned char>('\n'));
		}
		else {
			goto _loop28;
		}
		
	}
	_loop28:;
	}
	{
	if ((LA(1)==static_cast<unsigned char>('\n'))) {
		match(static_cast<unsigned char>('\n'));
	}
	else {
	}
	
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mID(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = ID;
	int _saveIndex;
	
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('a'):
	case static_cast<unsigned char>('b'):
	case static_cast<unsigned char>('c'):
	case static_cast<unsigned char>('d'):
	case static_cast<unsigned char>('e'):
	case static_cast<unsigned char>('f'):
	case static_cast<unsigned char>('g'):
	case static_cast<unsigned char>('h'):
	case static_cast<unsigned char>('i'):
	case static_cast<unsigned char>('j'):
	case static_cast<unsigned char>('k'):
	case static_cast<unsigned char>('l'):
	case static_cast<unsigned char>('m'):
	case static_cast<unsigned char>('n'):
	case static_cast<unsigned char>('o'):
	case static_cast<unsigned char>('p'):
	case static_cast<unsigned char>('q'):
	case static_cast<unsigned char>('r'):
	case static_cast<unsigned char>('s'):
	case static_cast<unsigned char>('t'):
	case static_cast<unsigned char>('u'):
	case static_cast<unsigned char>('v'):
	case static_cast<unsigned char>('w'):
	case static_cast<unsigned char>('x'):
	case static_cast<unsigned char>('y'):
	case static_cast<unsigned char>('z'):
	{
		matchRange(static_cast<unsigned char>('a'),static_cast<unsigned char>('z'));
		break;
	}
	case static_cast<unsigned char>('A'):
	case static_cast<unsigned char>('B'):
	case static_cast<unsigned char>('C'):
	case static_cast<unsigned char>('D'):
	case static_cast<unsigned char>('E'):
	case static_cast<unsigned char>('F'):
	case static_cast<unsigned char>('G'):
	case static_cast<unsigned char>('H'):
	case static_cast<unsigned char>('I'):
	case static_cast<unsigned char>('J'):
	case static_cast<unsigned char>('K'):
	case static_cast<unsigned char>('L'):
	case static_cast<unsigned char>('M'):
	case static_cast<unsigned char>('N'):
	case static_cast<unsigned char>('O'):
	case static_cast<unsigned char>('P'):
	case static_cast<unsigned char>('Q'):
	case static_cast<unsigned char>('R'):
	case static_cast<unsigned char>('S'):
	case static_cast<unsigned char>('T'):
	case static_cast<unsigned char>('U'):
	case static_cast<unsigned char>('V'):
	case static_cast<unsigned char>('W'):
	case static_cast<unsigned char>('X'):
	case static_cast<unsigned char>('Y'):
	case static_cast<unsigned char>('Z'):
	{
		matchRange(static_cast<unsigned char>('A'),static_cast<unsigned char>('Z'));
		break;
	}
	case static_cast<unsigned char>('_'):
	{
		match(static_cast<unsigned char>('_'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	{
	for (;;) {
		switch ( LA(1)) {
		case static_cast<unsigned char>('a'):
		case static_cast<unsigned char>('b'):
		case static_cast<unsigned char>('c'):
		case static_cast<unsigned char>('d'):
		case static_cast<unsigned char>('e'):
		case static_cast<unsigned char>('f'):
		case static_cast<unsigned char>('g'):
		case static_cast<unsigned char>('h'):
		case static_cast<unsigned char>('i'):
		case static_cast<unsigned char>('j'):
		case static_cast<unsigned char>('k'):
		case static_cast<unsigned char>('l'):
		case static_cast<unsigned char>('m'):
		case static_cast<unsigned char>('n'):
		case static_cast<unsigned char>('o'):
		case static_cast<unsigned char>('p'):
		case static_cast<unsigned char>('q'):
		case static_cast<unsigned char>('r'):
		case static_cast<unsigned char>('s'):
		case static_cast<unsigned char>('t'):
		case static_cast<unsigned char>('u'):
		case static_cast<unsigned char>('v'):
		case static_cast<unsigned char>('w'):
		case static_cast<unsigned char>('x'):
		case static_cast<unsigned char>('y'):
		case static_cast<unsigned char>('z'):
		{
			matchRange(static_cast<unsigned char>('a'),static_cast<unsigned char>('z'));
			break;
		}
		case static_cast<unsigned char>('A'):
		case static_cast<unsigned char>('B'):
		case static_cast<unsigned char>('C'):
		case static_cast<unsigned char>('D'):
		case static_cast<unsigned char>('E'):
		case static_cast<unsigned char>('F'):
		case static_cast<unsigned char>('G'):
		case static_cast<unsigned char>('H'):
		case static_cast<unsigned char>('I'):
		case static_cast<unsigned char>('J'):
		case static_cast<unsigned char>('K'):
		case static_cast<unsigned char>('L'):
		case static_cast<unsigned char>('M'):
		case static_cast<unsigned char>('N'):
		case static_cast<unsigned char>('O'):
		case static_cast<unsigned char>('P'):
		case static_cast<unsigned char>('Q'):
		case static_cast<unsigned char>('R'):
		case static_cast<unsigned char>('S'):
		case static_cast<unsigned char>('T'):
		case static_cast<unsigned char>('U'):
		case static_cast<unsigned char>('V'):
		case static_cast<unsigned char>('W'):
		case static_cast<unsigned char>('X'):
		case static_cast<unsigned char>('Y'):
		case static_cast<unsigned char>('Z'):
		{
			matchRange(static_cast<unsigned char>('A'),static_cast<unsigned char>('Z'));
			break;
		}
		case static_cast<unsigned char>('_'):
		{
			match(static_cast<unsigned char>('_'));
			break;
		}
		case static_cast<unsigned char>('0'):
		case static_cast<unsigned char>('1'):
		case static_cast<unsigned char>('2'):
		case static_cast<unsigned char>('3'):
		case static_cast<unsigned char>('4'):
		case static_cast<unsigned char>('5'):
		case static_cast<unsigned char>('6'):
		case static_cast<unsigned char>('7'):
		case static_cast<unsigned char>('8'):
		case static_cast<unsigned char>('9'):
		{
			matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('9'));
			break;
		}
		default:
		{
			goto _loop43;
		}
		}
	}
	_loop43:;
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mTYPENAME(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = TYPENAME;
	int _saveIndex;
	
	try {      // for error handling
		mID(false);
		mGWS(false);
		{
		for (;;) {
			if ((LA(1)==static_cast<unsigned char>(':'))) {
				match("::");
				mGWS(false);
				mID(false);
				mGWS(false);
			}
			else {
				goto _loop116;
			}
			
		}
		_loop116:;
		}
		{
		if ((LA(1)==static_cast<unsigned char>('<'))) {
			mTEMPLATE_ARGS(false);
		}
		else {
		}
		
		}
	}
	catch (RecognitionException& ex) {
		if (inputState->guessing==0) {

			
					throw Error("Bad Typename");
				

		} else {
			throw ex;
		}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mFLAG(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = FLAG;
	int _saveIndex;

	
	bool negated = false;
	

	
	try {      // for error handling
		_saveIndex=text.length();
		match(static_cast<unsigned char>('-'));
		text.erase(_saveIndex);
		{
		bool synPredMatched39 = false;
		if (((LA(1)==static_cast<unsigned char>('n')))) {
			int _m39 = mark();
			synPredMatched39 = true;
			inputState->guessing++;
			try {
				{
				match("no_");
				}
			}
			catch (antlr::RecognitionException& pe) {
				synPredMatched39 = false;
			}
			rewind(_m39);
			inputState->guessing--;
		}
		if ( synPredMatched39 ) {
			match("no_");
			if ( inputState->guessing==0 ) {

				negated=true;

			}
		}
		else if ((_tokenSet_2.member(LA(1)))) {
		}
		else {
			throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
		}
		
		}
		if ( inputState->guessing==0 ) {

			text = negated ? "-" : "+";

		}
		mID(false);
	}
	catch (RecognitionException& ex) {
		if (inputState->guessing==0) {

			
						throw Error("Bad flag setting");
				

		} else {
			throw ex;
		}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mCHAR(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = CHAR;
	int _saveIndex;
	
	try {      // for error handling
		mAPOSTROPHE(false);
		{
		if ((_tokenSet_6.member(LA(1)))) {
			mCHAR_BODY(false);
		}
		else if ((LA(1)==static_cast<unsigned char>('"'))) {
			mQUOTES(false);
		}
		else {
			throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
		}
		
		}
		_saveIndex = text.length();
		mAPOSTROPHE(false);
		text.erase(_saveIndex);
	}
	catch (RecognitionException& ex) {
		if (inputState->guessing==0) {

			
					throw Error("Bad char literal");
				

		} else {
			throw ex;
		}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mSTRING(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = STRING;
	int _saveIndex;
	
	try {      // for error handling
		mQUOTES(false);
		{
		for (;;) {
			if ((_tokenSet_6.member(LA(1)))) {
				mCHAR_BODY(false);
			}
			else if ((LA(1)==static_cast<unsigned char>('\''))) {
				mAPOSTROPHE(false);
			}
			else {
				goto _loop104;
			}
			
		}
		_loop104:;
		}
		_saveIndex = text.length();
		mQUOTES(false);
		text.erase(_saveIndex);
	}
	catch (RecognitionException& ex) {
		if (inputState->guessing==0) {

			
					throw Error("Bad string literal");
				

		} else {
			throw ex;
		}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mTENTATIVE(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = TENTATIVE;
	int _saveIndex;
	
	bool synPredMatched20 = false;
	if (((_tokenSet_7.member(LA(1))))) {
		int _m20 = mark();
		synPredMatched20 = true;
		inputState->guessing++;
		try {
			{
			mREAL(false);
			{
			if ((_tokenSet_8.member(LA(1)))) {
				{
				match(_tokenSet_8);
				}
			}
			else if (true&&(LA(1)==EOF_CHAR)) {
			}
			else {
				throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
			}
			
			}
			}
		}
		catch (antlr::RecognitionException& pe) {
			synPredMatched20 = false;
		}
		rewind(_m20);
		inputState->guessing--;
	}
	if ( synPredMatched20 ) {
		mREAL(false);
		if ( inputState->guessing==0 ) {

			text = 'R' + text;

		}
	}
	else {
		bool synPredMatched24 = false;
		if (((_tokenSet_9.member(LA(1))))) {
			int _m24 = mark();
			synPredMatched24 = true;
			inputState->guessing++;
			try {
				{
				mINT(false);
				{
				if ((_tokenSet_8.member(LA(1)))) {
					{
					match(_tokenSet_8);
					}
				}
				else if (true&&(LA(1)==EOF_CHAR)) {
				}
				else {
					throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
				}
				
				}
				}
			}
			catch (antlr::RecognitionException& pe) {
				synPredMatched24 = false;
			}
			rewind(_m24);
			inputState->guessing--;
		}
		if ( synPredMatched24 ) {
			mINT(false);
			if ( inputState->guessing==0 ) {

				text = 'I' + text;

			}
		}
		else if ((_tokenSet_10.member(LA(1)))) {
			mFREE_STRING(false);
			if ( inputState->guessing==0 ) {

				text = 'S' + text;

			}
		}
	else {
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mURL(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = URL;
	int _saveIndex;
	
	try {      // for error handling
		_saveIndex=text.length();
		match(static_cast<unsigned char>('@'));
		text.erase(_saveIndex);
		{
		for (;;) {
			if ((_tokenSet_1.member(LA(1)))) {
				_saveIndex = text.length();
				mWS(false);
				text.erase(_saveIndex);
			}
			else {
				goto _loop32;
			}
			
		}
		_loop32:;
		}
		mURL_NAME(false);
	}
	catch (RecognitionException& ex) {
		if (inputState->guessing==0) {

			
					throw Error("Bad URL name");
				

		} else {
			throw ex;
		}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mREAL(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = REAL;
	int _saveIndex;
	
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('+'):
	case static_cast<unsigned char>('-'):
	{
		mSIGN(false);
		break;
	}
	case static_cast<unsigned char>('.'):
	case static_cast<unsigned char>('0'):
	case static_cast<unsigned char>('1'):
	case static_cast<unsigned char>('2'):
	case static_cast<unsigned char>('3'):
	case static_cast<unsigned char>('4'):
	case static_cast<unsigned char>('5'):
	case static_cast<unsigned char>('6'):
	case static_cast<unsigned char>('7'):
	case static_cast<unsigned char>('8'):
	case static_cast<unsigned char>('9'):
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	{
	bool synPredMatched94 = false;
	if (((_tokenSet_11.member(LA(1))))) {
		int _m94 = mark();
		synPredMatched94 = true;
		inputState->guessing++;
		try {
			{
			mFLOATING_POINT_MANTISA(false);
			}
		}
		catch (antlr::RecognitionException& pe) {
			synPredMatched94 = false;
		}
		rewind(_m94);
		inputState->guessing--;
	}
	if ( synPredMatched94 ) {
		mFLOATING_POINT_MANTISA(false);
		{
		if ((LA(1)==static_cast<unsigned char>('E')||LA(1)==static_cast<unsigned char>('e'))) {
			mEXPONENT(false);
		}
		else {
		}
		
		}
	}
	else if (((LA(1) >= static_cast<unsigned char>('1') && LA(1) <= static_cast<unsigned char>('9')))) {
		mUNSIGNED_DEC_INT(false);
		mEXPONENT(false);
	}
	else {
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	
	}
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('f'):
	{
		match(static_cast<unsigned char>('f'));
		break;
	}
	case static_cast<unsigned char>('F'):
	{
		match(static_cast<unsigned char>('F'));
		break;
	}
	case static_cast<unsigned char>('l'):
	{
		match(static_cast<unsigned char>('l'));
		break;
	}
	case static_cast<unsigned char>('L'):
	{
		match(static_cast<unsigned char>('L'));
		break;
	}
	default:
		{
		}
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mINT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = INT;
	int _saveIndex;

	
	char long_qualifier = 'X';
	char unsigned_qualifier = 'X';
	char base;
	

	
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('+'):
	case static_cast<unsigned char>('-'):
	{
		mSIGN(false);
		break;
	}
	case static_cast<unsigned char>('0'):
	case static_cast<unsigned char>('1'):
	case static_cast<unsigned char>('2'):
	case static_cast<unsigned char>('3'):
	case static_cast<unsigned char>('4'):
	case static_cast<unsigned char>('5'):
	case static_cast<unsigned char>('6'):
	case static_cast<unsigned char>('7'):
	case static_cast<unsigned char>('8'):
	case static_cast<unsigned char>('9'):
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	{
	bool synPredMatched75 = false;
	if (((LA(1)==static_cast<unsigned char>('0')))) {
		int _m75 = mark();
		synPredMatched75 = true;
		inputState->guessing++;
		try {
			{
			mHEX_MARKER(false);
			}
		}
		catch (antlr::RecognitionException& pe) {
			synPredMatched75 = false;
		}
		rewind(_m75);
		inputState->guessing--;
	}
	if ( synPredMatched75 ) {
		mUNSIGNED_HEX_INT(false);
		if ( inputState->guessing==0 ) {

			base='H';

		}
	}
	else {
		bool synPredMatched77 = false;
		if (((LA(1)==static_cast<unsigned char>('0')))) {
			int _m77 = mark();
			synPredMatched77 = true;
			inputState->guessing++;
			try {
				{
				mBIN_MARKER(false);
				}
			}
			catch (antlr::RecognitionException& pe) {
				synPredMatched77 = false;
			}
			rewind(_m77);
			inputState->guessing--;
		}
		if ( synPredMatched77 ) {
			mUNSIGNED_BIN_INT(false);
			if ( inputState->guessing==0 ) {

				base='B';

			}
		}
		else if ((LA(1)==static_cast<unsigned char>('0'))) {
			mUNSIGNED_OCT_INT(false);
			if ( inputState->guessing==0 ) {

				base='O';

			}
		}
		else if (((LA(1) >= static_cast<unsigned char>('1') && LA(1) <= static_cast<unsigned char>('9')))) {
			mUNSIGNED_DEC_INT(false);
			if ( inputState->guessing==0 ) {

				base='D';

			}
		}
	else {
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	{
	if ((LA(1)==static_cast<unsigned char>('U')||LA(1)==static_cast<unsigned char>('u'))) {
		mUNSIGNED_QUALIFIER(false);
		if ( inputState->guessing==0 ) {

			unsigned_qualifier = 'U';

		}
	}
	else {
	}
	
	}
	{
	if ((LA(1)==static_cast<unsigned char>('L')||LA(1)==static_cast<unsigned char>('l'))) {
		mLONG_QUALIFIER(false);
		if ( inputState->guessing==0 ) {

			long_qualifier = 'L';

		}
	}
	else {
	}
	
	}
	if ( inputState->guessing==0 ) {

		
			  text = string(1,base) + unsigned_qualifier + long_qualifier + text;
			

	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mFREE_STRING(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = FREE_STRING;
	int _saveIndex;
	
	mFIRST_FREE_CHAR(false);
	{
	for (;;) {
		switch ( LA(1)) {
		case static_cast<unsigned char>('.'):
		case static_cast<unsigned char>('/'):
		case static_cast<unsigned char>('0'):
		case static_cast<unsigned char>('1'):
		case static_cast<unsigned char>('2'):
		case static_cast<unsigned char>('3'):
		case static_cast<unsigned char>('4'):
		case static_cast<unsigned char>('5'):
		case static_cast<unsigned char>('6'):
		case static_cast<unsigned char>('7'):
		case static_cast<unsigned char>('8'):
		case static_cast<unsigned char>('9'):
		case static_cast<unsigned char>('A'):
		case static_cast<unsigned char>('B'):
		case static_cast<unsigned char>('C'):
		case static_cast<unsigned char>('D'):
		case static_cast<unsigned char>('E'):
		case static_cast<unsigned char>('F'):
		case static_cast<unsigned char>('G'):
		case static_cast<unsigned char>('H'):
		case static_cast<unsigned char>('I'):
		case static_cast<unsigned char>('J'):
		case static_cast<unsigned char>('K'):
		case static_cast<unsigned char>('L'):
		case static_cast<unsigned char>('M'):
		case static_cast<unsigned char>('N'):
		case static_cast<unsigned char>('O'):
		case static_cast<unsigned char>('P'):
		case static_cast<unsigned char>('Q'):
		case static_cast<unsigned char>('R'):
		case static_cast<unsigned char>('S'):
		case static_cast<unsigned char>('T'):
		case static_cast<unsigned char>('U'):
		case static_cast<unsigned char>('V'):
		case static_cast<unsigned char>('W'):
		case static_cast<unsigned char>('X'):
		case static_cast<unsigned char>('Y'):
		case static_cast<unsigned char>('Z'):
		case static_cast<unsigned char>('\\'):
		case static_cast<unsigned char>('_'):
		case static_cast<unsigned char>('a'):
		case static_cast<unsigned char>('b'):
		case static_cast<unsigned char>('c'):
		case static_cast<unsigned char>('d'):
		case static_cast<unsigned char>('e'):
		case static_cast<unsigned char>('f'):
		case static_cast<unsigned char>('g'):
		case static_cast<unsigned char>('h'):
		case static_cast<unsigned char>('i'):
		case static_cast<unsigned char>('j'):
		case static_cast<unsigned char>('k'):
		case static_cast<unsigned char>('l'):
		case static_cast<unsigned char>('m'):
		case static_cast<unsigned char>('n'):
		case static_cast<unsigned char>('o'):
		case static_cast<unsigned char>('p'):
		case static_cast<unsigned char>('q'):
		case static_cast<unsigned char>('r'):
		case static_cast<unsigned char>('s'):
		case static_cast<unsigned char>('t'):
		case static_cast<unsigned char>('u'):
		case static_cast<unsigned char>('v'):
		case static_cast<unsigned char>('w'):
		case static_cast<unsigned char>('x'):
		case static_cast<unsigned char>('y'):
		case static_cast<unsigned char>('z'):
		{
			mFIRST_FREE_CHAR(false);
			break;
		}
		case static_cast<unsigned char>('-'):
		{
			match(static_cast<unsigned char>('-'));
			break;
		}
		default:
		{
			goto _loop47;
		}
		}
	}
	_loop47:;
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mURL_NAME(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = URL_NAME;
	int _saveIndex;
	
	{
	int _cnt35=0;
	for (;;) {
		switch ( LA(1)) {
		case static_cast<unsigned char>('a'):
		case static_cast<unsigned char>('b'):
		case static_cast<unsigned char>('c'):
		case static_cast<unsigned char>('d'):
		case static_cast<unsigned char>('e'):
		case static_cast<unsigned char>('f'):
		case static_cast<unsigned char>('g'):
		case static_cast<unsigned char>('h'):
		case static_cast<unsigned char>('i'):
		case static_cast<unsigned char>('j'):
		case static_cast<unsigned char>('k'):
		case static_cast<unsigned char>('l'):
		case static_cast<unsigned char>('m'):
		case static_cast<unsigned char>('n'):
		case static_cast<unsigned char>('o'):
		case static_cast<unsigned char>('p'):
		case static_cast<unsigned char>('q'):
		case static_cast<unsigned char>('r'):
		case static_cast<unsigned char>('s'):
		case static_cast<unsigned char>('t'):
		case static_cast<unsigned char>('u'):
		case static_cast<unsigned char>('v'):
		case static_cast<unsigned char>('w'):
		case static_cast<unsigned char>('x'):
		case static_cast<unsigned char>('y'):
		case static_cast<unsigned char>('z'):
		{
			matchRange(static_cast<unsigned char>('a'),static_cast<unsigned char>('z'));
			break;
		}
		case static_cast<unsigned char>('A'):
		case static_cast<unsigned char>('B'):
		case static_cast<unsigned char>('C'):
		case static_cast<unsigned char>('D'):
		case static_cast<unsigned char>('E'):
		case static_cast<unsigned char>('F'):
		case static_cast<unsigned char>('G'):
		case static_cast<unsigned char>('H'):
		case static_cast<unsigned char>('I'):
		case static_cast<unsigned char>('J'):
		case static_cast<unsigned char>('K'):
		case static_cast<unsigned char>('L'):
		case static_cast<unsigned char>('M'):
		case static_cast<unsigned char>('N'):
		case static_cast<unsigned char>('O'):
		case static_cast<unsigned char>('P'):
		case static_cast<unsigned char>('Q'):
		case static_cast<unsigned char>('R'):
		case static_cast<unsigned char>('S'):
		case static_cast<unsigned char>('T'):
		case static_cast<unsigned char>('U'):
		case static_cast<unsigned char>('V'):
		case static_cast<unsigned char>('W'):
		case static_cast<unsigned char>('X'):
		case static_cast<unsigned char>('Y'):
		case static_cast<unsigned char>('Z'):
		{
			matchRange(static_cast<unsigned char>('A'),static_cast<unsigned char>('Z'));
			break;
		}
		case static_cast<unsigned char>('0'):
		case static_cast<unsigned char>('1'):
		case static_cast<unsigned char>('2'):
		case static_cast<unsigned char>('3'):
		case static_cast<unsigned char>('4'):
		case static_cast<unsigned char>('5'):
		case static_cast<unsigned char>('6'):
		case static_cast<unsigned char>('7'):
		case static_cast<unsigned char>('8'):
		case static_cast<unsigned char>('9'):
		{
			matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('9'));
			break;
		}
		case static_cast<unsigned char>('_'):
		{
			match(static_cast<unsigned char>('_'));
			break;
		}
		case static_cast<unsigned char>('-'):
		{
			match(static_cast<unsigned char>('-'));
			break;
		}
		case static_cast<unsigned char>('/'):
		{
			match(static_cast<unsigned char>('/'));
			break;
		}
		case static_cast<unsigned char>('\\'):
		{
			match(static_cast<unsigned char>('\\'));
			break;
		}
		case static_cast<unsigned char>(':'):
		{
			match(static_cast<unsigned char>(':'));
			break;
		}
		case static_cast<unsigned char>('.'):
		{
			match(static_cast<unsigned char>('.'));
			break;
		}
		default:
		{
			if ( _cnt35>=1 ) { goto _loop35; } else {throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());}
		}
		}
		_cnt35++;
	}
	_loop35:;
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mFIRST_FREE_CHAR(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = FIRST_FREE_CHAR;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('a'):
	case static_cast<unsigned char>('b'):
	case static_cast<unsigned char>('c'):
	case static_cast<unsigned char>('d'):
	case static_cast<unsigned char>('e'):
	case static_cast<unsigned char>('f'):
	case static_cast<unsigned char>('g'):
	case static_cast<unsigned char>('h'):
	case static_cast<unsigned char>('i'):
	case static_cast<unsigned char>('j'):
	case static_cast<unsigned char>('k'):
	case static_cast<unsigned char>('l'):
	case static_cast<unsigned char>('m'):
	case static_cast<unsigned char>('n'):
	case static_cast<unsigned char>('o'):
	case static_cast<unsigned char>('p'):
	case static_cast<unsigned char>('q'):
	case static_cast<unsigned char>('r'):
	case static_cast<unsigned char>('s'):
	case static_cast<unsigned char>('t'):
	case static_cast<unsigned char>('u'):
	case static_cast<unsigned char>('v'):
	case static_cast<unsigned char>('w'):
	case static_cast<unsigned char>('x'):
	case static_cast<unsigned char>('y'):
	case static_cast<unsigned char>('z'):
	{
		matchRange(static_cast<unsigned char>('a'),static_cast<unsigned char>('z'));
		break;
	}
	case static_cast<unsigned char>('A'):
	case static_cast<unsigned char>('B'):
	case static_cast<unsigned char>('C'):
	case static_cast<unsigned char>('D'):
	case static_cast<unsigned char>('E'):
	case static_cast<unsigned char>('F'):
	case static_cast<unsigned char>('G'):
	case static_cast<unsigned char>('H'):
	case static_cast<unsigned char>('I'):
	case static_cast<unsigned char>('J'):
	case static_cast<unsigned char>('K'):
	case static_cast<unsigned char>('L'):
	case static_cast<unsigned char>('M'):
	case static_cast<unsigned char>('N'):
	case static_cast<unsigned char>('O'):
	case static_cast<unsigned char>('P'):
	case static_cast<unsigned char>('Q'):
	case static_cast<unsigned char>('R'):
	case static_cast<unsigned char>('S'):
	case static_cast<unsigned char>('T'):
	case static_cast<unsigned char>('U'):
	case static_cast<unsigned char>('V'):
	case static_cast<unsigned char>('W'):
	case static_cast<unsigned char>('X'):
	case static_cast<unsigned char>('Y'):
	case static_cast<unsigned char>('Z'):
	{
		matchRange(static_cast<unsigned char>('A'),static_cast<unsigned char>('Z'));
		break;
	}
	case static_cast<unsigned char>('_'):
	{
		match(static_cast<unsigned char>('_'));
		break;
	}
	case static_cast<unsigned char>('0'):
	case static_cast<unsigned char>('1'):
	case static_cast<unsigned char>('2'):
	case static_cast<unsigned char>('3'):
	case static_cast<unsigned char>('4'):
	case static_cast<unsigned char>('5'):
	case static_cast<unsigned char>('6'):
	case static_cast<unsigned char>('7'):
	case static_cast<unsigned char>('8'):
	case static_cast<unsigned char>('9'):
	{
		matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('9'));
		break;
	}
	case static_cast<unsigned char>('/'):
	{
		match(static_cast<unsigned char>('/'));
		break;
	}
	case static_cast<unsigned char>('\\'):
	{
		match(static_cast<unsigned char>('\\'));
		break;
	}
	case static_cast<unsigned char>('.'):
	{
		match(static_cast<unsigned char>('.'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mDIGIT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = DIGIT;
	int _saveIndex;
	
	matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('9'));
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mHEX_DIGIT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = HEX_DIGIT;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('0'):
	case static_cast<unsigned char>('1'):
	case static_cast<unsigned char>('2'):
	case static_cast<unsigned char>('3'):
	case static_cast<unsigned char>('4'):
	case static_cast<unsigned char>('5'):
	case static_cast<unsigned char>('6'):
	case static_cast<unsigned char>('7'):
	case static_cast<unsigned char>('8'):
	case static_cast<unsigned char>('9'):
	{
		matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('9'));
		break;
	}
	case static_cast<unsigned char>('a'):
	case static_cast<unsigned char>('b'):
	case static_cast<unsigned char>('c'):
	case static_cast<unsigned char>('d'):
	case static_cast<unsigned char>('e'):
	case static_cast<unsigned char>('f'):
	{
		matchRange(static_cast<unsigned char>('a'),static_cast<unsigned char>('f'));
		break;
	}
	case static_cast<unsigned char>('A'):
	case static_cast<unsigned char>('B'):
	case static_cast<unsigned char>('C'):
	case static_cast<unsigned char>('D'):
	case static_cast<unsigned char>('E'):
	case static_cast<unsigned char>('F'):
	{
		matchRange(static_cast<unsigned char>('A'),static_cast<unsigned char>('F'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mOCT_DIGIT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = OCT_DIGIT;
	int _saveIndex;
	
	matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('7'));
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mBIN_DIGIT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = BIN_DIGIT;
	int _saveIndex;
	
	matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('1'));
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mSIGN(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = SIGN;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('+'):
	{
		match(static_cast<unsigned char>('+'));
		break;
	}
	case static_cast<unsigned char>('-'):
	{
		match(static_cast<unsigned char>('-'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mHEX_MARKER(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = HEX_MARKER;
	int _saveIndex;
	
	match(static_cast<unsigned char>('0'));
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('x'):
	{
		match(static_cast<unsigned char>('x'));
		break;
	}
	case static_cast<unsigned char>('X'):
	{
		match(static_cast<unsigned char>('X'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mBIN_MARKER(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = BIN_MARKER;
	int _saveIndex;
	
	match(static_cast<unsigned char>('0'));
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('b'):
	{
		match(static_cast<unsigned char>('b'));
		break;
	}
	case static_cast<unsigned char>('B'):
	{
		match(static_cast<unsigned char>('B'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mUNSIGNED_DEC_INT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = UNSIGNED_DEC_INT;
	int _saveIndex;
	
	matchRange(static_cast<unsigned char>('1'),static_cast<unsigned char>('9'));
	{
	for (;;) {
		if (((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('9')))) {
			mDIGIT(false);
		}
		else {
			goto _loop59;
		}
		
	}
	_loop59:;
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mUNSIGNED_OCT_INT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = UNSIGNED_OCT_INT;
	int _saveIndex;
	
	match(static_cast<unsigned char>('0'));
	{
	for (;;) {
		if (((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('7')))) {
			mOCT_DIGIT(false);
		}
		else {
			goto _loop62;
		}
		
	}
	_loop62:;
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mUNSIGNED_HEX_INT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = UNSIGNED_HEX_INT;
	int _saveIndex;
	
	mHEX_MARKER(false);
	{
	int _cnt65=0;
	for (;;) {
		if ((_tokenSet_12.member(LA(1)))) {
			mHEX_DIGIT(false);
		}
		else {
			if ( _cnt65>=1 ) { goto _loop65; } else {throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());}
		}
		
		_cnt65++;
	}
	_loop65:;
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mUNSIGNED_BIN_INT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = UNSIGNED_BIN_INT;
	int _saveIndex;
	
	mBIN_MARKER(false);
	{
	int _cnt68=0;
	for (;;) {
		if ((LA(1)==static_cast<unsigned char>('0')||LA(1)==static_cast<unsigned char>('1'))) {
			mBIN_DIGIT(false);
		}
		else {
			if ( _cnt68>=1 ) { goto _loop68; } else {throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());}
		}
		
		_cnt68++;
	}
	_loop68:;
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mUNSIGNED_QUALIFIER(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = UNSIGNED_QUALIFIER;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('U'):
	{
		match(static_cast<unsigned char>('U'));
		break;
	}
	case static_cast<unsigned char>('u'):
	{
		match(static_cast<unsigned char>('u'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mLONG_QUALIFIER(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = LONG_QUALIFIER;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('L'):
	{
		match(static_cast<unsigned char>('L'));
		break;
	}
	case static_cast<unsigned char>('l'):
	{
		match(static_cast<unsigned char>('l'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mFLOATING_POINT_MANTISA(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = FLOATING_POINT_MANTISA;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('0'):
	case static_cast<unsigned char>('1'):
	case static_cast<unsigned char>('2'):
	case static_cast<unsigned char>('3'):
	case static_cast<unsigned char>('4'):
	case static_cast<unsigned char>('5'):
	case static_cast<unsigned char>('6'):
	case static_cast<unsigned char>('7'):
	case static_cast<unsigned char>('8'):
	case static_cast<unsigned char>('9'):
	{
		{
		int _cnt82=0;
		for (;;) {
			if (((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('9')))) {
				mDIGIT(false);
			}
			else {
				if ( _cnt82>=1 ) { goto _loop82; } else {throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());}
			}
			
			_cnt82++;
		}
		_loop82:;
		}
		match(static_cast<unsigned char>('.'));
		{
		for (;;) {
			if (((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('9')))) {
				mDIGIT(false);
			}
			else {
				goto _loop84;
			}
			
		}
		_loop84:;
		}
		break;
	}
	case static_cast<unsigned char>('.'):
	{
		match(static_cast<unsigned char>('.'));
		{
		int _cnt86=0;
		for (;;) {
			if (((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('9')))) {
				mDIGIT(false);
			}
			else {
				if ( _cnt86>=1 ) { goto _loop86; } else {throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());}
			}
			
			_cnt86++;
		}
		_loop86:;
		}
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mEXPONENT(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = EXPONENT;
	int _saveIndex;
	
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('e'):
	{
		match(static_cast<unsigned char>('e'));
		break;
	}
	case static_cast<unsigned char>('E'):
	{
		match(static_cast<unsigned char>('E'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('+'):
	case static_cast<unsigned char>('-'):
	{
		mSIGN(false);
		break;
	}
	case static_cast<unsigned char>('1'):
	case static_cast<unsigned char>('2'):
	case static_cast<unsigned char>('3'):
	case static_cast<unsigned char>('4'):
	case static_cast<unsigned char>('5'):
	case static_cast<unsigned char>('6'):
	case static_cast<unsigned char>('7'):
	case static_cast<unsigned char>('8'):
	case static_cast<unsigned char>('9'):
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	mUNSIGNED_DEC_INT(false);
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mAPOSTROPHE(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = APOSTROPHE;
	int _saveIndex;
	
	match(static_cast<unsigned char>('\''));
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mQUOTES(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = QUOTES;
	int _saveIndex;
	
	match(static_cast<unsigned char>('"'));
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mBACKSLASH(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = BACKSLASH;
	int _saveIndex;
	
	match(static_cast<unsigned char>('\\'));
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mCHAR_BODY(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = CHAR_BODY;
	int _saveIndex;
	
	if ((_tokenSet_13.member(LA(1)))) {
		{
		match(_tokenSet_13);
		}
	}
	else {
		bool synPredMatched108 = false;
		if (((LA(1)==static_cast<unsigned char>('\\')))) {
			int _m108 = mark();
			synPredMatched108 = true;
			inputState->guessing++;
			try {
				{
				mHEX_ESC_CHAR_BODY(false);
				}
			}
			catch (antlr::RecognitionException& pe) {
				synPredMatched108 = false;
			}
			rewind(_m108);
			inputState->guessing--;
		}
		if ( synPredMatched108 ) {
			mHEX_ESC_CHAR_BODY(false);
		}
		else if ((LA(1)==static_cast<unsigned char>('\\'))) {
			mBACKSLASH(false);
			matchNot(EOF/*_CHAR*/);
		}
	else {
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mHEX_ESC_CHAR_BODY(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = HEX_ESC_CHAR_BODY;
	int _saveIndex;
	
	mBACKSLASH(false);
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('x'):
	{
		match(static_cast<unsigned char>('x'));
		break;
	}
	case static_cast<unsigned char>('X'):
	{
		match(static_cast<unsigned char>('X'));
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	mHEX_DIGIT(false);
	mHEX_DIGIT(false);
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mGWS(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = GWS;
	int _saveIndex;
	
	{
	for (;;) {
		if ((_tokenSet_1.member(LA(1)))) {
			_saveIndex = text.length();
			mWS(false);
			text.erase(_saveIndex);
		}
		else {
			goto _loop113;
		}
		
	}
	_loop113:;
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mTEMPLATE_ARGS(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = TEMPLATE_ARGS;
	int _saveIndex;
	
	match(static_cast<unsigned char>('<'));
	mGWS(false);
	mONE_TEMPLATE_ARG(false);
	mGWS(false);
	{
	for (;;) {
		if ((LA(1)==static_cast<unsigned char>(','))) {
			match(static_cast<unsigned char>(','));
			mGWS(false);
			mONE_TEMPLATE_ARG(false);
			mGWS(false);
		}
		else {
			goto _loop120;
		}
		
	}
	_loop120:;
	}
	match(static_cast<unsigned char>('>'));
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mONE_TEMPLATE_ARG(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = ONE_TEMPLATE_ARG;
	int _saveIndex;
	
	mPOSSIBLE_CONST(false);
	mTYPENAME(false);
	mGWS(false);
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('*'):
	{
		match(static_cast<unsigned char>('*'));
		break;
	}
	case static_cast<unsigned char>('\1'):
	case static_cast<unsigned char>('\t'):
	case static_cast<unsigned char>('\n'):
	case static_cast<unsigned char>('\r'):
	case static_cast<unsigned char>(' '):
	case static_cast<unsigned char>(','):
	case static_cast<unsigned char>('>'):
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	}
	}
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void xParamLexer::mPOSSIBLE_CONST(bool _createToken) {
	int _ttype; antlr::RefToken _token; int _begin=text.length();
	_ttype = POSSIBLE_CONST;
	int _saveIndex;
	
	bool synPredMatched125 = false;
	if (((LA(1)==static_cast<unsigned char>('c')))) {
		int _m125 = mark();
		synPredMatched125 = true;
		inputState->guessing++;
		try {
			{
			match("const");
			mWS(false);
			}
		}
		catch (antlr::RecognitionException& pe) {
			synPredMatched125 = false;
		}
		rewind(_m125);
		inputState->guessing--;
	}
	if ( synPredMatched125 ) {
		match("const");
		{
		int _cnt127=0;
		for (;;) {
			if ((_tokenSet_1.member(LA(1)))) {
				_saveIndex = text.length();
				mWS(false);
				text.erase(_saveIndex);
			}
			else {
				if ( _cnt127>=1 ) { goto _loop127; } else {throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());}
			}
			
			_cnt127++;
		}
		_loop127:;
		}
		if ( inputState->guessing==0 ) {

			text+=' ';

		}
	}
	else if ((_tokenSet_2.member(LA(1)))) {
	}
	else {
		throw antlr::NoViableAltForCharException(LA(1), getFilename(), getLine());
	}
	
	if ( _createToken && _token==antlr::nullToken && _ttype!=antlr::Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}


const unsigned long xParamLexer::_tokenSet_0_data_[] = { 9730UL, 738196365UL, 3221225471UL, 805306366UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_0(_tokenSet_0_data_,10);
const unsigned long xParamLexer::_tokenSet_1_data_[] = { 9730UL, 1UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_1(_tokenSet_1_data_,10);
const unsigned long xParamLexer::_tokenSet_2_data_[] = { 0UL, 0UL, 2281701374UL, 134217726UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_2(_tokenSet_2_data_,10);
const unsigned long xParamLexer::_tokenSet_3_data_[] = { 4294967295UL, 4294909951UL, 4026531839UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_3(_tokenSet_3_data_,16);
const unsigned long xParamLexer::_tokenSet_4_data_[] = { 0UL, 67102720UL, 2550136830UL, 134217726UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_4(_tokenSet_4_data_,10);
const unsigned long xParamLexer::_tokenSet_5_data_[] = { 4294966271UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_5(_tokenSet_5_data_,16);
const unsigned long xParamLexer::_tokenSet_6_data_[] = { 4294967295UL, 4294967163UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_6(_tokenSet_6_data_,16);
const unsigned long xParamLexer::_tokenSet_7_data_[] = { 0UL, 67069952UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_7(_tokenSet_7_data_,10);
const unsigned long xParamLexer::_tokenSet_8_data_[] = { 4294967295UL, 4227866623UL, 1744830465UL, 4160749569UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_8(_tokenSet_8_data_,16);
const unsigned long xParamLexer::_tokenSet_9_data_[] = { 0UL, 67053568UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_9(_tokenSet_9_data_,10);
const unsigned long xParamLexer::_tokenSet_10_data_[] = { 0UL, 67092480UL, 2550136830UL, 134217726UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_10(_tokenSet_10_data_,10);
const unsigned long xParamLexer::_tokenSet_11_data_[] = { 0UL, 67059712UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_11(_tokenSet_11_data_,10);
const unsigned long xParamLexer::_tokenSet_12_data_[] = { 0UL, 67043328UL, 126UL, 126UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_12(_tokenSet_12_data_,10);
const unsigned long xParamLexer::_tokenSet_13_data_[] = { 4294967295UL, 4294967163UL, 4026531839UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
const antlr::BitSet xParamLexer::_tokenSet_13(_tokenSet_13_data_,16);

ANTLR_END_NAMESPACE
