/*	Copyright (C) 2001,2002,2003 Ronnie Maor and Michael Brand
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * As a special exception, the copyright holders give permission
 * for additional uses of the text contained in its release of XPARAM.
 *
 * The exception is that, if you link the XPARAM library with other files
 * to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the XPARAM library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * If you write modifications of your own for XPARAM, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.  
 */

#ifndef INC_xParamLexerTokenTypes_hpp_
#define INC_xParamLexerTokenTypes_hpp_

ANTLR_BEGIN_NAMESPACE(xParam_internal)
/* $ANTLR 2.7.1: "lexer.g" -> "xParamLexerTokenTypes.hpp"$ */
struct xParamLexerTokenTypes {
	enum {
		EOF_ = 1,
		// ";" = 4
		ID = 5,
		URL = 6,
		// "=" = 7
		FLAG = 8,
		TYPENAME = 9,
		// "(" = 10
		// ")" = 11
		// "[" = 12
		// "]" = 13
		// "," = 14
		TENTATIVE = 15,
		CHAR = 16,
		STRING = 17,
		GLUE_CHAR = 18,
		WS = 19,
		SINGLE_LINE_WS = 20,
		MAIN_SWITCH = 21,
		RESERVED_SYMBOL = 22,
		COMMENT = 23,
		URL_NAME = 24,
		FIRST_FREE_CHAR = 25,
		FREE_STRING = 26,
		DIGIT = 27,
		HEX_DIGIT = 28,
		OCT_DIGIT = 29,
		BIN_DIGIT = 30,
		SIGN = 31,
		HEX_MARKER = 32,
		BIN_MARKER = 33,
		UNSIGNED_DEC_INT = 34,
		UNSIGNED_OCT_INT = 35,
		UNSIGNED_HEX_INT = 36,
		UNSIGNED_BIN_INT = 37,
		UNSIGNED_QUALIFIER = 38,
		LONG_QUALIFIER = 39,
		INT = 40,
		FLOATING_POINT_MANTISA = 41,
		EXPONENT = 42,
		REAL = 43,
		APOSTROPHE = 44,
		QUOTES = 45,
		BACKSLASH = 46,
		CHAR_BODY = 47,
		HEX_ESC_CHAR_BODY = 48,
		GWS = 49,
		TEMPLATE_ARGS = 50,
		ONE_TEMPLATE_ARG = 51,
		POSSIBLE_CONST = 52,
		NULL_TREE_LOOKAHEAD = 3
	};
};
ANTLR_END_NAMESPACE
#endif /*INC_xParamLexerTokenTypes_hpp_*/
