//  Simple base class for use with the Boost demonstration program.
//
//  Copyright 2002 Jim Hyslop, all rights reserved
// 
//  Permission to copy, use, modify, sell and distribute this software
//  is granted provided this copyright notice appears in all copies.
//  This software is provided "as is" without express or implied
//  warranty, and with no claim as to its suitability for any purpose.
//
// This software has been tested with version 1.28.0 of the Boost
// library (released May 16, 2002). See www.boost.org to download Boost.

#ifndef BASE_CLASS_BOOST_SHARED_pTR_DEMO_DEFINED
#define BASE_CLASS_BOOST_SHARED_pTR_DEMO_DEFINED

#include <boost/shared_ptr.hpp>

class Base
{
    // Using the pointer-to-implementation (Pimpl) idiom
    // (also known as the handle-body idiom).
    class BaseImpl;
    boost::shared_ptr<BaseImpl> impl_;
public:
    virtual ~Base();

    // Normally, the compiler-generated versions of these functions
    // would suffice. I want this demonstration program to give a
    // running commentary on what's happening.
    Base();
    Base(const Base &);
    Base & operator=(const Base &);

    // Helper to show what's happening
    int showUseCount() const { return impl_.use_count(); }
};

#endif
